# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from cob_hand_bridge/Status.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import cob_hand_bridge.msg
import genpy

class Status(genpy.Message):
  _md5sum = "d1e9c755cdcb7c29d72650239e9eb91a"
  _type = "cob_hand_bridge/Status"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """uint32 seq
time stamp

uint8 NOT_INITIALIZED=0
uint8 MASK_FINGER_READY=1
uint8 MASK_GPIO_READY=2
uint8 MASK_ERROR=4
uint8 status

uint8 RC_OK=0
uint8 rc

uint32 pins

JointValues joints

================================================================================
MSG: cob_hand_bridge/JointValues
int16[2] position_cdeg
int16[2] velocity_cdeg_s
int16[2] current_100uA"""
  # Pseudo-constants
  NOT_INITIALIZED = 0
  MASK_FINGER_READY = 1
  MASK_GPIO_READY = 2
  MASK_ERROR = 4
  RC_OK = 0

  __slots__ = ['seq','stamp','status','rc','pins','joints']
  _slot_types = ['uint32','time','uint8','uint8','uint32','cob_hand_bridge/JointValues']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       seq,stamp,status,rc,pins,joints

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Status, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.seq is None:
        self.seq = 0
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.status is None:
        self.status = 0
      if self.rc is None:
        self.rc = 0
      if self.pins is None:
        self.pins = 0
      if self.joints is None:
        self.joints = cob_hand_bridge.msg.JointValues()
    else:
      self.seq = 0
      self.stamp = genpy.Time()
      self.status = 0
      self.rc = 0
      self.pins = 0
      self.joints = cob_hand_bridge.msg.JointValues()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I2BI().pack(_x.seq, _x.stamp.secs, _x.stamp.nsecs, _x.status, _x.rc, _x.pins))
      buff.write(_get_struct_2h().pack(*self.joints.position_cdeg))
      buff.write(_get_struct_2h().pack(*self.joints.velocity_cdeg_s))
      buff.write(_get_struct_2h().pack(*self.joints.current_100uA))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.joints is None:
        self.joints = cob_hand_bridge.msg.JointValues()
      end = 0
      _x = self
      start = end
      end += 18
      (_x.seq, _x.stamp.secs, _x.stamp.nsecs, _x.status, _x.rc, _x.pins,) = _get_struct_3I2BI().unpack(str[start:end])
      start = end
      end += 4
      self.joints.position_cdeg = _get_struct_2h().unpack(str[start:end])
      start = end
      end += 4
      self.joints.velocity_cdeg_s = _get_struct_2h().unpack(str[start:end])
      start = end
      end += 4
      self.joints.current_100uA = _get_struct_2h().unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I2BI().pack(_x.seq, _x.stamp.secs, _x.stamp.nsecs, _x.status, _x.rc, _x.pins))
      buff.write(self.joints.position_cdeg.tostring())
      buff.write(self.joints.velocity_cdeg_s.tostring())
      buff.write(self.joints.current_100uA.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.joints is None:
        self.joints = cob_hand_bridge.msg.JointValues()
      end = 0
      _x = self
      start = end
      end += 18
      (_x.seq, _x.stamp.secs, _x.stamp.nsecs, _x.status, _x.rc, _x.pins,) = _get_struct_3I2BI().unpack(str[start:end])
      start = end
      end += 4
      self.joints.position_cdeg = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=2)
      start = end
      end += 4
      self.joints.velocity_cdeg_s = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=2)
      start = end
      end += 4
      self.joints.current_100uA = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=2)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I2BI = None
def _get_struct_3I2BI():
    global _struct_3I2BI
    if _struct_3I2BI is None:
        _struct_3I2BI = struct.Struct("<3I2BI")
    return _struct_3I2BI
_struct_2h = None
def _get_struct_2h():
    global _struct_2h
    if _struct_2h is None:
        _struct_2h = struct.Struct("<2h")
    return _struct_2h
